﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace WinGridResizingOnRuntime
{
    public partial class Form1 : Form
    {
        enum Edge { None,Right, Bottom, RightLeft};
        public Form1()
        {
            InitializeComponent();
            ultraPanel1.Tag = Edge.None;
        }

        private void ultraPanel1_MouseDown(object sender, MouseEventArgs e)
        {

            if (WhereTheMouse(e) != Edge.None)
            {
                ultraPanel1.Capture = true;
            }
        }

        private void ultraPanel1_Move(object sender, EventArgs e)
        {
           
        }

        private void ultraPanel1_MouseUp(object sender, MouseEventArgs e)
        {
            ultraPanel1.Capture = true;
        }

        private void Form1_MouseHover(object sender, EventArgs e)
        {
            
        }

        private void ultraPanel1_MouseHover(object sender, EventArgs e)
        {
            
        }

        private void ultraPanel1_MouseMove(object sender, MouseEventArgs e)
        {
           
            Debug.WriteLine(e.Location.ToString());
            if (ultraPanel1.Capture)
            {
                int x = ultraPanel1.Size.Width ;
                int y = ultraPanel1.Size.Height ;

                switch ((Edge)ultraPanel1.Tag)
                {
                    case Edge.Right:
                         x = ultraPanel1.Size.Width + (e.X - ultraPanel1.Size.Width);
                         y = ultraPanel1.Size.Height;
                        break;
                    case Edge.Bottom:
                         x = ultraPanel1.Size.Width;
                         y = ultraPanel1.Size.Height + (e.Y - ultraPanel1.Size.Height);;
                        break;
                    case Edge.RightLeft:
                         x = ultraPanel1.Size.Width + (e.X - ultraPanel1.Size.Width);
                         y = ultraPanel1.Size.Height + (e.Y - ultraPanel1.Size.Height);
                        break;
                }

                ultraPanel1.Size = new Size(x, y);
            }
            else
            {
                switch (WhereTheMouse(e))
                {
                    case Edge.Right:
                        ultraPanel1.Cursor = Cursors.SizeWE;
                        ultraPanel1.Tag = Edge.Right;
                        break;
                    case Edge.Bottom:
                        ultraPanel1.Cursor = Cursors.SizeNS;
                        ultraPanel1.Tag = Edge.Bottom;
                        break;
                    case Edge.RightLeft:
                        ultraPanel1.Cursor = Cursors.SizeNWSE;
                        ultraPanel1.Tag = Edge.RightLeft;
                        break;
                    default:
                        ultraPanel1.Cursor = Cursors.Default;
                        ultraPanel1.Tag = Edge.None;
                        break;
                }
               
            }
           

        }

        private Edge WhereTheMouse(MouseEventArgs e)
        {
            Edge edge = Edge.None;
            if (ultraPanel1.Size.Width - 3 < e.X && e.X < ultraPanel1.Size.Width)
            {
                edge = Edge.Right;
              
            }
            if (ultraPanel1.Size.Height - 3 < e.Y && e.Y < ultraPanel1.Size.Height)
            {
                switch (edge)
                {
                    case Edge.None:
                        edge = Edge.Bottom;
                        break;
                    case Edge.Right:
                        edge = Edge.RightLeft;
                        break;
                }
            }
            return edge;
        }
    }
}
